import sys

import covjson2pandas
import requests

collection = "observations"
base_url = f"https://api.dataplatform.knmi.nl/edr/collections/{collection}"
token = "<YOUR TOKEN>"
headers = {"Authorization": token}


def metadata():
    r = requests.get(base_url, headers=headers)
    r.raise_for_status()
    return r.json()


def locations():
    r = requests.get(base_url + "/locations", headers=headers)
    r.raise_for_status()
    return r.json()


def position(params):
    r = requests.get(base_url + "/position", params, headers=headers)
    r.raise_for_status()
    df = covjson2pandas.convert_covjson_to_dataframe(r.json())

    return df


def main():
    md = metadata()
    print(md["extent"]["temporal"]["interval"])

    locs = locations()
    print([f["properties"]["name"] for f in locs["features"]])

    params = {
        "coord": "POINT(5.14527777777778 51.8577777777778)",
        "datetime": "2022-07-19T06:00:00Z/2022-07-19T18:00:00Z",
        "parameter-name": "t_dryb_10",
    }
    print(position(params))


if __name__ == "__main__":
    sys.exit(main())
