import logging
import sys
import requests

logging.basicConfig()
logger = logging.getLogger(__name__)
logger.setLevel("INFO")


api_key = "your-key"

url = "https://api.dataplatform.knmi.nl/geospatial-server/wms"
params = {
    "dataset": "wins50",
    "service": "WMS",
    "version": "1.3.0",
    "request": "GetMap",
    "layers": "wspeed",
    "crs": "EPSG:3857",
    "bbox": "383350.1,6709750.8,912139.6,7053300.2",
    "time": "2020-12-28T05:00:00Z",
    "elevation": 10,
    "styles": "auto/nearest",
    "format": "image/png",
    "width": 700,
    "height": 500,
    "transparent": "TRUE",
}

try:
    with requests.get(url,headers={"Authorization": api_key}, params=params, stream=True) as r:
        r.raise_for_status()
        with open("mytest.png", "wb") as f:
            counter = 0
            for chunk in r.iter_content(chunk_size=8192):
                counter += 1
                logger.info(f"write chunk {counter}")
                f.write(chunk)
except Exception:
    logger.exception("Unable to download file using download URL")
    sys.exit(1)
