timport logging
import sys
import requests

logging.basicConfig()
logger = logging.getLogger(__name__)
logger.setLevel("INFO")

api_url = "https://api.dataplatform.knmi.nl/open-data"
api_version = "v1"
api_key = "<API_KEY>"

dataset_name = "<DATASET_NAME>"
dataset_version = "<DATASET_VERSION>"
filename = "<DATASET_FILE>"

endpoint = f"{api_url}/{api_version}/datasets/{dataset_name}/versions/{dataset_version}/files/{filename}/url"


def download_file_from_temporary_download_url(download_url, filename):
    try:
        with requests.get(download_url, stream=True) as r:
            r.raise_for_status()
            with open(filename, "wb") as f:
                counter = 0
                for chunk in r.iter_content(chunk_size=8192):
                    counter += 1
                    logger.info(f"write chunk {counter}")
                    f.write(chunk)
    except Exception:
        logger.exception("Unable to download file using download URL")
        sys.exit(1)

    logger.info(f"Successfully downloaded dataset file to {filename}")


get_file_response = requests.get(endpoint, headers={"Authorization": api_key})
if get_file_response.status_code != 200:
    logger.error("Unable to retrieve download url for file")
    logger.error(get_file_response.text)
    sys.exit(1)

download_url = get_file_response.json().get("temporaryDownloadUrl")
download_file_from_temporary_download_url(download_url, filename)
