import logging
import json
import requests

logging.basicConfig()
logger = logging.getLogger(__name__)
logger.setLevel("INFO")

api_url = "https://api.dataplatform.knmi.nl/open-data"
api_version = "v1"
api_key = "<API_KEY>"

dataset_name = "<DATASET_NAME>"
dataset_version = "<DATASET_VERSION>"
max_keys = 30
# start_after_filename_prefix = "<DATASET_FILE>"

list_files_response = requests.get(
    f"{api_url}/{api_version}/datasets/{dataset_name}/versions/{dataset_version}/files",
    headers={"Authorization": api_key},
    params={"maxKeys": max_keys}  # , "startAfterFilename": start_after_filename_prefix},
)
list_files = list_files_response.json()
logger.info(json.dumps(list_files, indent=4))
